Package net.sf.saxon.tree.iter

## Class EmptyIterator

- java.lang.Object
- - net.sf.saxon.tree.iter.EmptyIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `AtomizedValueIterator`, `SequenceIterator`, `GroundedIterator`, `LookaheadIterator`, `ReversibleIterator`, `UnfailingIterator`

      public class EmptyIterator
      extends java.lang.Object
      implements SequenceIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator, UnfailingIterator, AtomizedValueIterator

  EmptyIterator: an iterator over an empty sequence. Since such an iterator has no state, only one instance is required; therefore a singleton instance is available via the static getInstance() method.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `EmptyIterator()` | Protected constructor

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static EmptyIterator` | `emptyIterator()` |
    `static EmptyIterator` | `getInstance()` | Get an EmptyIterator, an iterator over an empty sequence.
    `int` | `getLength()` | Get the position of the last item in the sequence.
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `GroundedValue` | `getResidue()` | Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position.
    `EmptyIterator` | `getReverseIterator()` | Get another iterator over the same items, in reverse order.
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `GroundedValue` | `materialize()` | Return a Value containing all the items in the sequence returned by this SequenceIterator.
    `Item` | `next()` | Get the next item.
    `AtomicSequence` | `nextAtomizedValue()` | Deliver the atomic value that is next in the atomized result
    `static <T extends AtomicValue> AtomicIterator<T>` | `ofAtomic()` | Static method to get an empty AtomicIterator
    `static AxisIterator` | `ofNodes()` | Static method to get an empty AxisIterator

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.UnfailingIterator

      `forEach, toList`

- - ### Constructor Detail

    - #### EmptyIterator

          protected EmptyIterator()

      Protected constructor

  - ### Method Detail

    - #### getInstance

          public static EmptyIterator getInstance()

      Get an EmptyIterator, an iterator over an empty sequence.
      Returns:
        an EmptyIterator (in practice, this always returns the same one)

    - #### emptyIterator

          public static EmptyIterator emptyIterator()

    - #### nextAtomizedValue

          public AtomicSequence nextAtomizedValue()

      Deliver the atomic value that is next in the atomized result
      Specified by:
        `nextAtomizedValue` in interface `AtomizedValueIterator`
      Returns:
        the next atomic value

    - #### next

          public Item next()

      Get the next item.
      Specified by:
        `next` in interface `SequenceIterator`
      Specified by:
        `next` in interface `UnfailingIterator`
      Returns:
        the next item. For the EmptyIterator this is always null.

    - #### getLength

          public int getLength()

      Get the position of the last item in the sequence.
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the position of the last item in the sequence, always zero in this implementation

    - #### getReverseIterator

          public EmptyIterator getReverseIterator()

      Get another iterator over the same items, in reverse order.
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator`
      Returns:
        a reverse iterator over an empty sequence (in practice, it returns the same iterator each time)

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

    - #### materialize

          public GroundedValue materialize()

      Return a Value containing all the items in the sequence returned by this SequenceIterator. This should be an "in-memory" value, not a Closure.
      Specified by:
        `materialize` in interface `GroundedIterator`
      Specified by:
        `materialize` in interface `SequenceIterator`
      Returns:
        the corresponding Value

    - #### getResidue

          public GroundedValue getResidue()

      Description copied from interface: `GroundedIterator`
      Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position. This should be an "in-memory" value, not a Closure. This method does not change the state of the iterator (in particular, it does not consume the iterator).
      Specified by:
        `getResidue` in interface `GroundedIterator`
      Returns:
        the corresponding Value

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.
      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more nodes

    - #### ofNodes

          public static AxisIterator ofNodes()

      Static method to get an empty AxisIterator

    - #### ofAtomic

          public static <T extends AtomicValue> AtomicIterator<T> ofAtomic()

      Static method to get an empty AtomicIterator